#include "BehaviourChest.h"
#include "Level.h"
#include "LD.h"



BehaviourChest::BehaviourChest()
{
  m_Hits = 5;
  m_HitPause = 0;
  m_Opened = false;
  m_JustOpenedCount = 0;
}



void BehaviourChest::UpdateFixed( Level& Level, GameObject* pObj )
{

  if ( m_HitPause > 0 )
  {
    --m_HitPause;
  }

}



void BehaviourChest::OnEvent( Level& Level, const std::string& Event, GameObject* pObj, GameObject* pOtherObject )
{

  if ( Event == "Hit" )
  {
    if ( !m_Opened )
    {
      if ( m_HitPause == 0 )
      {
        m_HitPause = 20;
        --m_Hits;
        if ( m_Hits == 0 )
        {
          m_Opened = true;
          pObj->OnEvent( Level, "Opened", pObj, NULL );
          pObj->m_TexSection = LD::TEX_CHEST_OPEN;
          Level.ParseExtraData( pObj->m_ID );

          theApp.PlaySoundA( LD::SOUND_CHEST_OPEN );
        }
        else
        {
          theApp.PlaySoundA( LD::SOUND_HIT_POST );
        }
      }
    }
  }
  else if ( Event == "Open" )
  {
    m_Opened = true;
    pObj->m_TexSection = LD::TEX_CHEST_OPEN;
  }

}