#include "BehaviourPushback.h"
#include "Level.h"
#include "LD.h"



BehaviourPushback::BehaviourPushback( int Distance )
{
  m_MaxDist = Distance;
  m_DistanceToWalk = 0;
  m_WalkDX = 0;
  m_WalkDY = 0;
}



void BehaviourPushback::UpdateFixed( Level& Level, GameObject* pObj )
{

  if ( m_DistanceToWalk > 0 )
  {
    Level.WalkObject( pObj, 2 * m_WalkDX, 2 * m_WalkDY );
    --m_DistanceToWalk;
    if ( m_DistanceToWalk == 0 )
    {
      pObj->OnEvent( Level, "Thaw", pObj, NULL );
    }
  }

}



void BehaviourPushback::Update( Level& Level, float ElapsedTime, GameObject* pObj )
{
}



void BehaviourPushback::OnEvent( Level& Level, const std::string& Event, GameObject* pObj, GameObject* pOtherObject )
{

  if ( Event == "Hurt" )
  {
    pObj->OnEvent( Level, "Freeze", pObj, NULL );
    m_DistanceToWalk = m_MaxDist;

    float     angle = atan2f( (float)pOtherObject->m_Y - pObj->m_Y, (float)pObj->m_X - pOtherObject->m_X ) * 180.0f / 3.1415926f;

    if ( angle < 0 )
    {
      angle += 360.0f;
    }
    if ( angle >= 360.0f )
    {
      angle -= 360.0f;
    }
    if ( ( angle >= 0 )
    &&   ( angle < 22.5f ) )
    {
      m_WalkDX = 1;
      m_WalkDY = 0;
    }
    else if ( ( angle >= 0.0f + 22.5f )
    &&        ( angle < 90.0f - 22.5f ) )
    {
      m_WalkDX = 1;
      m_WalkDY = -1;
    }
    else if ( ( angle >= 90.0f - 22.5f )
    &&        ( angle < 90.0f + 22.5f ) )
    {
      m_WalkDX = 0;
      m_WalkDY = -1;
    }
    else if ( ( angle >= 90.0f + 22.5f )
    &&        ( angle < 180.0f - 22.5f ) )
    {
      m_WalkDX = -1;
      m_WalkDY = -1;
    }
    else if ( ( angle >= 180.0f - 22.5f )
    &&        ( angle < 180.0f + 22.5f ) )
    {
      m_WalkDX = -1;
      m_WalkDY = 0;
    }
    else if ( ( angle >= 180.0f + 22.5f )
    &&        ( angle < 270.0f - 22.5f ) )
    {
      m_WalkDX = -1;
      m_WalkDY = 1;
    }
    else if ( ( angle >= 270.0f - 22.5f )
    &&        ( angle < 270.0f + 22.5f ) )
    {
      m_WalkDX = 0;
      m_WalkDY = 1;
    }
    else if ( ( angle >= 270.0f + 22.5f )
    &&        ( angle < 360.0f - 22.5f ) )
    {
      m_WalkDX = 1;
      m_WalkDY = 1;
    }
    else if ( ( angle >= 360.0f - 22.5f )
    &&        ( angle < 360.0f ) )
    {
      m_WalkDX = 1;
      m_WalkDY = 0;
    }
  }

}