#pragma once
#include "gamestate.h"
#include "Level.h"



class CGSEdit : public CGameState
{

  public:

    enum EditMode
    {
      EM_TILES,
      EM_OBJECTS,

      EM_LAST_ENTRY
    };

    Level                   m_Level;

    EditMode                m_EditMode;

    LD::TileType            m_CurTile;

    LD::ObjectType          m_CurObjectType;

    bool                    m_ButtonReleased;

    GameObject*             m_pSelectedObj;

    std::string             m_EditWorld;



    CGSEdit();
    virtual ~CGSEdit();

    virtual void            Display( IDirect3DDevice8* pDevice );

    virtual void            UpdateFrame( const float fElapsedTime );
    virtual void            UpdateFixed();

    virtual void            OnChar( int iChar );
    virtual void            OnKeyDown( int iChar );
    virtual void            OnMouse( int X, int Y, int Buttons );

};
