#include <d3d8.h>

#include ".\GSGame.h"
#include ".\GSMenu.h"
#include ".\BehaviourPlayer.h"
#include ".\LD.h"



CGSGame::CGSGame()
{

  m_Level.Load( "world" );

  m_Level.m_pPlayer = new GameObject( 0, 0, LD::OT_PLAYER );
  m_Level.m_pPlayer->m_ID = -1;
  m_Level.AddObject( m_Level.m_pPlayer );

  m_Level.m_pPlayerBehaviour = (BehaviourPlayer*)m_Level.m_pPlayer->m_Behaviour.front();

}



CGSGame::~CGSGame()
{

}



void CGSGame::Display( IDirect3DDevice8* pDevice )
{

  theApp.m_pd3dDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, FALSE );

  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP, D3DTOP_MODULATE );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );

  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP, D3DTOP_MODULATE );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE );

  m_Level.Display();

  //m_Level.DisplayVisibleBounds();

  if ( m_Level.m_pPlayer )
  {
    RECT    bounds = m_Level.m_pPlayer->Bounds();

    /*
    char    temp[200];
    sprintf( temp, "ObjID: %d   Pos: %d,%d    Bounds: %d,%d - %d,%d", m_Level.m_pPlayer->m_ID, m_Level.m_pPlayer->m_X, m_Level.m_pPlayer->m_Y,
          bounds.left, bounds.top, bounds.right, bounds.bottom );
    theApp.Print( 5, 5, temp );
    */

    if ( m_Level.m_pPlayerBehaviour->m_CurWeapon != LD::OT_INVALID )
    {
      GameObject    objWeapon( 320 + m_Level.m_OffsetX - 320, 30 + m_Level.m_OffsetY - 240, m_Level.m_pPlayerBehaviour->m_CurWeapon );

      objWeapon.Display( m_Level );
    }
    std::string     weapon = "No Weapon";
    switch ( m_Level.m_pPlayerBehaviour->m_CurWeapon )
    {
      case LD::OT_AXE:
        weapon = "Axe";
        break;
      case LD::OT_GOLDEN_SWORD:
        weapon = "Golden Sword";
        break;
      case LD::OT_HAMMER:
        weapon = "Hammer";
        break;
      case LD::OT_SWORD:
        weapon = "Sword";
        break;
    }
    theApp.Print( 290, 52, weapon.c_str() );

    for ( int i = 0; i < m_Level.m_pPlayerBehaviour->m_HPMax; ++i )
    {
      if ( i < m_Level.m_pPlayerBehaviour->m_HP )
      {
        theApp.RenderTextureSection2d( 400 + i * 32, 5, theApp.m_TexSec[LD::TEX_HEART_FULL] );
      }
      else
      {
        theApp.RenderTextureSection2d( 400 + i * 32, 5, theApp.m_TexSec[LD::TEX_HEART_EMPTY] );
      }
    }
  }

  if ( m_Level.m_pPlayer == NULL )
  {
    theApp.PrintNiceCentered( 320, 200, "You have been killed" );
    theApp.PrintNiceCentered( 320, 230, "Press SPACE" );
  }

}



void CGSGame::UpdateFrame( const float ElapsedTime )
{

  m_Level.Update( ElapsedTime );

}



void CGSGame::UpdateFixed()
{

  m_Level.UpdateFixed();

}



void CGSGame::OnMouse( int X, int Y, int Buttons )
{

}



void CGSGame::OnChar( int iChar )
{

  if ( ( m_Level.m_pPlayer == NULL )
  &&   ( iChar == 32 ) )
  {
    theApp.NextState( new CGSMenu() );
  }
  if ( iChar == 27 )
  {
    theApp.NextState( new CGSMenu() );
  }

}



void CGSGame::OnKeyDown( int iChar )
{

}